/**
    -  Create excel file reader using apache poi
    -  parse data from excel by each sheets 
    -  insert data in varsatare table using get varsatare method
    -  Call remote method to invoke validate before inserting
*/


def name ='riyas.mohamed' 
// idFirma = 1;
println "Hello $name For Json Remoting !!" 
println "Bindings are - sql : " + sql + " idfirma: " + idFirma + " parentFolder: " + parentFolder + " jsonRemotingService: " + jsonRemotingService 

File file = new File(parentFolder,"varsetare.xls"); 
if(!file.exists()){
    throw new Exception("file not found..!");
}
def values=['numbers':[],'characters':[],'dates':[],"booleans":[]];

//citesc sheet 1 - CHARACTER
excelReader.iterateRow(file, 1,true, { reader->
  def variableName = reader.getString('Name')
  def explicatie = reader.getString('Description')
  def value = reader.getString('Value')

  //daca nu are nume sau e un nume gol -> trec peste ea
  if(variableName == null || variableName.trim().empty) {
    println("CHARACTER Sheet - Skipping row: variabile name is null")
  } else {
    //daca nu are valoare sau e o valoare goala -> trec peste ea
    if(value == null || value.trim().empty) {
      println "CHARACTER Sheet - Skipping row: variableName: ${variableName} value: ${value} "
    } else {
      def rowInsert=['name':variableName,'value':value, 'explicatie': explicatie]
      values.characters<<rowInsert;
      println "CHARACTER Sheet - Store row for insert : $rowInsert "
    }
  }
})

//citesc sheet 2 - NUMBER
excelReader.iterateRow(file, 2,true, { reader->
  def variableName = reader.getString('Name')
  def explicatie = reader.getString('Description')
  def value = reader.getNumber('Value')

  //daca nu are nume sau e un nume gol -> trec peste ea
  if(variableName == null || variableName.trim().empty) {
    println("NUMBER Sheet - Skipping row: variabile name is null")
  } else {
    //daca nu are valoare -> trec peste ea
    if(value == null) {
      println "NUMBER Sheet - Skipping row: variableName: ${variableName} value: ${value} "
    } else {
      value=value.setScale(5,java.math.RoundingMode.HALF_UP).stripTrailingZeros();
      println "NUMBER Sheet - Variabile  $variableName  has value: ${value.toPlainString()}"

      def rowInsert=['name':variableName,'value':value, 'explicatie': explicatie]
      values.numbers<<rowInsert;
      println "NUMBER Sheet - Store row for insert : $rowInsert "
    }
  }
})

//citesc sheet 3 - DATE

excelReader.iterateRow(file, 3,true, { reader->
  def variableName = reader.getString('Name')
  def explicatie = reader.getString('Description')
  def value = reader.getDate('Value', 'dd-MM-yyyy')

  //daca nu are nume sau e un nume gol -> trec peste ea
  if(variableName == null || variableName.trim().empty) {
    println("DATE Sheet - Skipping row: variabile name is null")
  } else {
    //daca nu are valoare sau e o valoare goala -> trec peste ea
    if(value == null) {
      println "DATE Sheet - Skipping row: variableName: ${variableName} value: ${value} "
    } else {
      println "DATE Sheet - Variabile  $variableName has value: ${value}"
      def rowInsert=['name':variableName,'value':value,'explicatie':explicatie]
      values.dates<<rowInsert;
      println "DATE Sheet - Store row for insert : $rowInsert "
    }
  }
})


//citesc sheet 4 - BOOLEAN
excelReader.iterateRow(file, 4,true, { reader->
  def variableName = reader.getString('Name')
  def explicatie = reader.getString('Description')
  def value = reader.getBoolean('Value')

  //daca nu are nume sau e un nume gol -> trec peste ea
  if(variableName == null || variableName.trim().empty) {
    println("BOOLEAN Sheet - Skipping row: variabile name is null")
  } else {
    //daca nu are valoare -> trec peste ea
    if(value == null) {
      println "BOOLEAN Sheet - Skipping row: variableName: ${variableName} value: ${value} "
    } else {
      println "BOOLEAN Sheet - Variabile  $variableName has value: ${value}"
      def rowInsert=['name':variableName,'value':value, 'explicatie': explicatie]
      values.booleans<<rowInsert;
      println "BOOLEAN Sheet - Store row for insert : $rowInsert "
    }
  }
})

// file.withInputStream {is->
    
//     Workbook workbook = new HSSFWorkbook(is);
    
    // iterateRows(workbook,"CHARACTER",{Row row, String variableName,String explicatie ->
    //     Cell valueCell=row.getCell(1);
    //     int type = valueCell.getCellType();
        
    //     // String value =valueCell==null?null: valueCell.stringCellValue;
    //     String value = null;
    //     if (type == Cell.CELL_TYPE_STRING) {
    //         try{
    //             value=valueCell.getStringCellValue();
    //         }catch(Exception ex){
    //             // ex.printStackTrace();
    //         }
    //     } else if (type == Cell.CELL_TYPE_NUMERIC) {
    //         try{
    //             value=new BigDecimal(valueCell.getNumericCellValue()).toPlainString();
    //         }catch(Exception ex){
    //             // ex.printStackTrace();
    //         }
    //     }
    //    // println "Character Sheet:  VariableName: ${variableName} Value: ${value} Explicate: ${explicatie}"
    //     if(value == null || value.trim().empty) {
    //         println "Skipping row : ${row.rowNum} on variableName: ${variableName} value: ${value} "
    //         return;
    //     }
    //     def rowInsert=['name':variableName,'value':value, 'explicatie': explicatie]
    //     values.characters<<rowInsert;
    //     println "Value of Chartacter Sheet : $rowInsert "
    // });

    // iterateRows(workbook,"NUMBER",{Row row, String variableName,String explicatie ->
        
    //     Cell valueCell=row.getCell(1)
    //     int type = valueCell.getCellType();   
    //     BigDecimal value =null;
       
    //     if (type == Cell.CELL_TYPE_STRING) {
    //         try{
    //             value=new BigDecimal(valueCell.getStringCellValue());
    //         }catch(Exception ex){
    //             // ex.printStackTrace();
    //         }
    //     } else if (type == Cell.CELL_TYPE_NUMERIC) {
    //         try{
    //             value=new BigDecimal(valueCell.getNumericCellValue());
    //         }catch(Exception ex){
    //             // ex.printStackTrace();
    //         }
    //     }
    //     if(value == null) {
    //         println "Skipping row : ${row.rowNum} on variableName: ${variableName} value: ${value} "
    //         return;
    //     }
        
        
    //     value=value.setScale(5,java.math.RoundingMode.HALF_UP).stripTrailingZeros();
    //     println "Variabile  $variableName  has value: ${value.toPlainString()} annd type:$type"

    //     def rowInsert=['name':variableName,'value':value, 'explicatie': explicatie]
    //     values.numbers<<rowInsert;
    //     println "Value of Number Sheet : $rowInsert"
    // });

    // iterateRows(workbook,"DATE",{Row row, String variableName,String explicatie ->
       
    //     def pattern = "dd-MM-YYYY";
    //     Cell valueCell=row.getCell(1)
    //     int type = valueCell.getCellType();
        
    //     Date value;
    //     if (type == Cell.CELL_TYPE_STRING) {
    //         try{
    //             value = Date.parse(pattern, valueCell.getStringCellValue()); 
    //         }catch(Exception ex){
    //             // ex.printStackTrace();
    //         }
    //     }
    //     if(value == null) {
    //         return;
    //     }
    //     def rowInsert=['name':variableName,'value':value,'explicatie':explicatie]
    //     println "Variabile  $variableName  has value: ${value} annd type:$type"
    //     values.dates<<rowInsert;
    //     println "Value of Date Sheet : $rowInsert"
    // });

//     iterateRows(workbook,"BOOLEAN",{Row row, String variableName,String explicatie ->
        
//         Cell valueCell=row.getCell(1)
//         int type = valueCell.getCellType();
//         boolean value;
//         if (type == Cell.CELL_TYPE_STRING) {
//             try{
//                 println "AM IN STRING CELL"
//                 String val=valueCell.getStringCellValue();
//                 println "Value In String Cell ${val}"
//                 if(val!=null&&!val.trim().empty){
//                     value="true".equalsIgnoreCase(val.trim());
//                 }
                
//             }catch(Exception ex){
//                 // ex.printStackTrace();
//             }
//         } else if(type == Cell.CELL_TYPE_NUMERIC){
//             try{
//                 println "AM IN NUMERIC CELL"
//                 Double val=new Double(valueCell.getNumericCellValue());
//                 println "Value In Numeric Cell ${val}"
//                 value = val.intValue()==0?false:true;
//             }catch(Exception ex){
//                 // ex.printStackTrace();
//             }   
//         } else if(type == Cell.CELL_TYPE_BOOLEAN){
// 			value=valueCell.getBooleanCellValue()
//         }
        
//         if(value == null) {
//             return;
//         }

//         def rowInsert=['name':variableName,'value':value,'explicatie':explicatie]
//         println "Variabile  $variableName  has value: ${value} annd type:$type"
//         values.booleans<<rowInsert;
//         println "Value of Date Sheet : $rowInsert"
//     });
// }

def updateClojure={variabile->
  if(variabile.explicatie==null){return;}
  def explicatie = StringUtils.left(variabile.explicatie, 1024)
  int value= sql.executeUpdate("UPDATE TOTAL.VARSETARE set EXPLICATIE=${explicatie} where VARIABILA=${variabile.name} and ID_FIRMA=${idFirma}")
  println("for ${variabile} id firma:${idFirma}  rows ${value}")
}
//to put here app in production
def warName="app";
values.numbers.each{variabile->   
    def returObject=jsonRemotingService.invokeRemote(warName, "varSetare","saveVarSetareNumeric",[idFirma, idUser, variabile.name, variabile.value]); 
    println "the object errorDetail ::: "+returObject.errorDetail; 
    println "the object errorMessage ::: "+returObject.errorMessage; 
    ///do sql update with explicatei
    updateClojure(variabile)
}

values.characters.each{variabile->
    def returObject=jsonRemotingService.invokeRemote(warName, "varSetare","saveVarSetareCharacter",[idFirma, idUser, variabile.name, variabile.value]); 
    println "the object errorDetail ::: "+returObject.errorDetail; 
    println "the object errorMessage ::: "+returObject.errorMessage; 
    updateClojure(variabile)
}

values.booleans.each{variabile->
    def returObject=jsonRemotingService.invokeRemote(warName, "varSetare","saveVarSetareBoolean",[idFirma, idUser, variabile.name, variabile.value]); 
    println "the object errorDetail ::: "+returObject.errorDetail; 
    println "the object errorMessage ::: "+returObject.errorMessage; 
    updateClojure(variabile)
}

values.dates.each{variabile->
    def returObject=jsonRemotingService.invokeRemote(warName, "varSetare","saveVarSetareDate",[idFirma, idUser, variabile.name, variabile.value]); 
    println "the object errorDetail ::: "+returObject.errorDetail; 
    println "the object errorMessage ::: "+returObject.errorMessage; 
    updateClojure(variabile)
}

HashMap<String, Object> map = new HashMap<>();
// def iterateRows(Workbook workbook, String sheetName, Closure validate){
//     Sheet foundSheet = null;
//     int numberOfSheets = workbook.getNumberOfSheets();
//     for(int i = 0; i< numberOfSheets; i++){
//         Sheet sh = workbook.getSheetAt(i);
//         String name = sh.getSheetName();
//         if(name !=null) {
//             name = name.trim();
//         }
//         if(sheetName.equalsIgnoreCase(name)){
//             foundSheet = sh;
//             break;
//         }
//     }
//     println("Found sheet ${foundSheet==null?'NOOO':foundSheet.sheetName}")
//     if(foundSheet==null){
//         return;
//     }
//     iterateRowSheet(foundSheet,validate);
// }

// def iterateRowSheet(org.apache.poi.ss.usermodel.Sheet sheet, Closure validate) {
//     if(sheet==null) {
//         return;
//     }
//     Iterator<Row> rowIt = sheet.iterator()
//     int rowIdx=0;
//     while(rowIt.hasNext()) {
//         rowIdx++;
//         Row row = rowIt.next();
// 		if(rowIdx==1){
//             continue;
//         }
//         Cell cellVariableName=row.getCell(0);
//         Cell cellExplicatie=row.getCell(2);
//         // println("cellVariableName name found:${cellVariableName}")
//         String variableName = cellVariableName?.getStringCellValue();     
//         String explicatie = cellExplicatie?.getStringCellValue();    
  
//         println("Variabile name found:${variableName}")
//         if(variableName == null || variableName.trim().empty) {
//             println("Skipping Row:${variableName} Row No: ${row.rowNum}")
//             continue;
//         }
//         if(variableName !=null) {
//             validate(row,variableName,explicatie)
//         }
//     }
// }

import org.apache.poi.ss.usermodel.*;
import org.apache.poi.ss.util.*
import org.apache.poi.xssf.usermodel.*
import org.apache.poi.hssf.usermodel.*;
import org.apache.commons.lang.StringUtils;

